int latchPin = 2;  // pin 12 on the 595
int dataPin = 3;   // pin 14 on the 595
int clockPin = 4;  // pin 11 on the 595

int timer = 500;

int CC[11] = {63,6,91,79,192,109,125,7,127,103,0};    // CC array.
// int CA[11] = {64,121,36,48,25,18,2,120,0,24,127};  // CA array.
// Last item in each array is a 'blank'.

int D1 = 128;   // LED pin 12.
int D2 = 256;   // LED pin 9.
int D3 = 512;   // LED pin 8.
int D4 = 1024;  // LED pin 6.

// Common Cathode requires a LOW on the LED digit select pin (12,9,8,6) to complete the electric circuit.
// D2 + D3 + D4 enabled (HIGH) means only D1 is disabled (LOW), therefore circuit is complete and 1st LED lights.
 
//////////////////////////////////////////
void setup() {
  pinMode(latchPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
}
//////////////////////////////////////////
void loop() {
  // 0 on first digit.
  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, MSBFIRST, D2 + D3 + D4 + CC[0] >> 8);  // Positive signals to D2, D3, D4 disables them.
  shiftOut(dataPin, clockPin, MSBFIRST, D2 + D3 + D4 + CC[0]);       // Shift data pattern 8 bits to include 2nd '595.
  digitalWrite(latchPin, HIGH);                                      
  delay(timer);

  // 1 on second digit.
  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, MSBFIRST, D1 + D3 + D4 + CC[1] >> 8); // Positive signals to D1, D3, D4 disables them.
  shiftOut(dataPin, clockPin, MSBFIRST, D1 + D3 + D4 + CC[1]);  
  digitalWrite(latchPin, HIGH);
  delay(timer);
  
  // 2 on third digit.
  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, MSBFIRST, D1 + D2 + D4 + CC[2] >> 8); // Positive signals to D1, D2, D4 disables them.
  shiftOut(dataPin, clockPin, MSBFIRST, D1 + D2 + D4 + CC[2]);  
  digitalWrite(latchPin, HIGH);
  delay(timer);

  // 3 on fourth digit.
  digitalWrite(latchPin, LOW);
  shiftOut(dataPin, clockPin, MSBFIRST, D1 + D2 + D3 + CC[3] >> 8); // Positive signals to D1, D2, D3 disables them.
  shiftOut(dataPin, clockPin, MSBFIRST, D1 + D2 + D3 + CC[3]);  
  digitalWrite(latchPin, HIGH);
  delay(timer);
}
